C*********************************************************************
 
C...UPINIT
C...Dummy routine, to be replaced by a user implementing external
C...processes. Is supposed to fill the HEPRUP commonblock with info
C...on incoming beams and allowed processes.

C...New example: handles a standard Les Houches Events File.

      SUBROUTINE UPINIT
*...	HERWIG common blocks
      INCLUDE 'HERWIG65.INC'

*...Les Houches Agreement I common blocks
      INCLUDE 'LHA.INC'

      INTEGER I,IBEG,IPR,MAXLEN
      INTEGER ISMEAR,IS,IST,NEVPY
      CHARACTER XXX*500,EVFILE*500,CMPRS*500
      COMMON/ISMEAR/ISMEAR
      COMMON/INPARM/IS,IST,NEVPY
      SAVE

C...Lines to read in assumed never longer than 200 characters. 
      PARAMETER (MAXLEN=200)
      CHARACTER*(MAXLEN) STRING

C...Format for reading lines.
      CHARACTER*6 STRFMT
      STRFMT='(A000)'
      WRITE(STRFMT(3:5),'(I3)') MAXLEN

C...Loop until finds line beginning with "<init>" or "<init ". 
  100 READ(IS,STRFMT,END=130,ERR=130) STRING
      IBEG=0
  110 IBEG=IBEG+1
C...Allow indentation.
      IF(STRING(IBEG:IBEG).EQ.' '.AND.IBEG.LT.MAXLEN-5) GOTO 110 
      IF(STRING(IBEG:IBEG+5).NE.'<init>'.AND.
     &STRING(IBEG:IBEG+5).NE.'<init ') GOTO 100

C...Read first line of initialization info.
      READ(IS,*,END=130,ERR=130) IDBMUP(1),IDBMUP(2),EBMUP(1),
     &EBMUP(2),PDFGUP(1),PDFGUP(2),PDFSUP(1),PDFSUP(2),IDWTUP,NPRUP

      DO I=1,2
        IF(PDFGUP(I).LT.1) THEN
          PDFGUP(I) = -1
        ENDIF
        IF(PDFGUP(I).GT.9) THEN
          MODPDF(I) = PDFGUP(I)
          AUTPDF(I) = 'HWLHAPDF'
        ENDIF
      ENDDO

C...Read NPRUP subsequent lines with information on each process.
      DO 120 IPR=1,NPRUP
        READ(IS,*,END=130,ERR=130) XSECUP(IPR),XERRUP(IPR),
     &  XMAXUP(IPR),LPRUP(IPR)
  120 CONTINUE
      RETURN

C...Error exit: give up if initalization does not work.
  130 WRITE(*,*) ' Failed to read LHEF initialization information.'
      WRITE(*,*) ' Event generation will be stopped.'
      CALL HWWARN('UPINIT',598)

      RETURN
      END
