*************************************************************************
*        Routine to smear the resonance mass according  to Breit-Wigner *
*                  CompHEP 4.10  -  PYTHIA 6.2 interface                *
*************************************************************************
*  15.12.99         A. Belyaev, V.Ilyin                                 *
*  06.11.2000       some corrections (XM -> PMAS), V.Ilyin              *
*  25.11.2001       update to Pythia 6.2 by V.Ilyin                     *
*************************************************************************
      SUBROUTINE SMEARMASS
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
*...CompHEP-PYTHIA interface
      COMMON/SUBPROC/NNUP(100),KFP(100,20),
     .               NEV(100),XM(100,20,3),SIGMA(100),NPROC
      SAVE

      REAL*8 PX,PX1(20,5),PX2(20,5),PX3(20,5),PXX(20,5)

*...some values in lab frame
      PLAB=PUP(3,1)+PUP(3,2)
      ELAB=PUP(4,1)+PUP(4,2)
      SHAT=(ELAB-PLAB)*(ELAB+PLAB)

*...loop over the particles in final state
      DO I=3,NUP
      
*...if unstable particle then smeare its mass
      IF(PMAS(ABS(IDUP(I)),2).gt.0.) THEN

*...transfer out-momenta to REAL*8
      DO 100 j=1,NUP
      DO 100 k=1,5
100     PX1(j,k)=PUP(k,j)

*...invariant mass of the cluster recoiled the Ith particle
       IF(NUP.EQ.4) THEN              ! 2->2 case
         IF(I.eq.3) PM2=PX1(4,5)
         IF(I.eq.4) PM2=PX1(3,5)
       ELSE
         PX = sqrt(PX1(I,1)**2+PX1(I,2)**2+(PLAB-PX1(I,3))**2)
         PM2=(ELAB-PX1(I,4)-PX)*(ELAB-PX1(I,4)+PX)
         IF(PM2.lt.0.) PM2=abs(PM2)
         PM2=sqrt(PM2)
       ENDIF
 
*...boost of all momenta to partonic CMS
       GAMMA = 1.d0/(sqrt(ELAB-PLAB)*sqrt(ELAB+PLAB))
       DO j=1,NUP
          PX2(j,1)=PX1(j,1)
          PX2(j,2)=PX1(j,2)
          PX2(j,3) = GAMMA*(-PLAB*PX1(j,4)+ELAB*PX1(j,3))
          PX2(j,4) = GAMMA*( ELAB*PX1(j,4)-PLAB*PX1(j,3))
          PX2(j,5)=PX1(j,5)
       ENDDO

*...defs for Breit-Wigner measure
       PMAV = PX2(I,5)
       WIDTH = PMAS(ABS(IDUP(I)),2)
       WBAND = PMAS(ABS(IDUP(I)),3)
       PMUP = WBAND+PMAV
       PMDN =-WBAND+PMAV
       ATL=ATAN((PMDN**2-PMAV**2)/(PMAV*WIDTH))
       ATU=ATAN((PMUP**2-PMAV**2)/(PMAV*WIDTH))
       
*...BW smearing of the mass of Ith particle
555    PM1=sqrt(PMAV**2+PMAV*WIDTH*TAN(ATL+PYR(0)*(ATU-ATL)))
       PX3(I,5)=PM1                         ! new mass of Ith particle

*...new energy of the Ith particle in partonic CMS
       E1N = (PM1**2-PM2**2 + SHAT)/2.d0/SQRT(SHAT)
       IF(E1N.le.PM1) goto 555   !check masses
       PX3(I,4)=E1N
*...old and new energy of the recoiled cluster in partonic CMS
       E2  = sqrt(SHAT)-PX2(I,4)
       E2N = sqrt(SHAT)-E1N
       IF(E2N.le.PM2) goto 555   !check masses

*...old space momenta of the Ith particle and recoiled cluster in partonic CMS
       PMOD=sqrt(PX2(I,1)**2+ PX2(I,2)**2+PX2(I,3)**2)	  
*...new space momenta of the Ith particle and recoiled cluster in partonic CMS
       PMODN=sqrt(E1N-PM1)*sqrt(E1N+PM1)
*...new space components of the Ith momentum in partonic CMS via rescaling
       DO k=1,3
         PXX(I,k)=PX2(I,k)/PMOD
         PX3(I,k)=PXX(I,k)*PMODN
       ENDDO

*...new momentum of the recoiled particle in 2->2 case
       IF(NUP.eq.4) THEN
         IF(I.eq.3) I2=4
         IF(I.eq.4) I2=3
         PX3(I2,1)=-PX3(I,1)
         PX3(I2,2)=-PX3(I,2)
         PX3(I2,3)=-PX3(I,3)
         PX3(I2,4)= E2N
         PX3(I2,5)= PM2
         GOTO 333
       ENDIF

*...new momenta for other out particles (neq Ith)
       GAMMA = 1.d0/sqrt((E2-PMOD)*(E2N+PMODN))
     &        *1.d0/sqrt((E2+PMOD)*(E2N-PMODN))
       DO j=3,NUP
        IF(j.ne.I) then
          PJL=-(PX2(j,1)*PXX(I,1)+PX2(j,2)*PXX(I,2)+PX2(j,3)*PXX(I,3))
          PJLN=GAMMA*(-(E2N*PMOD-E2*PMODN)*PX2(j,4)
     &                +(E2*E2N-PMOD*PMODN)*PJL)
          PX3(j,4)=GAMMA*((E2*E2N-PMOD*PMODN)*PX2(j,4)
     &                   -(E2N*PMOD-E2*PMODN)*PJL)
          PX3(j,1)=PX2(j,1)-(PJLN-PJL)*PXX(I,1)
          PX3(j,2)=PX2(j,2)-(PJLN-PJL)*PXX(I,2)
          PX3(j,3)=PX2(j,3)-(PJLN-PJL)*PXX(I,3)
          PX3(j,5)=PX2(j,5) 
        ENDIF
       ENDDO

333    CONTINUE
*...boost from partonic CMS to the lab frame
       GAMMA = 1.d0/(sqrt(ELAB-PLAB)*sqrt(ELAB+PLAB))
       DO j=3,NUP
          PUP(1,j)=PX3(j,1)
          PUP(2,j)=PX3(j,2)
          PUP(3,j) = GAMMA*(PLAB*PX3(j,4)+ELAB*PX3(j,3))
          PUP(4,j) = GAMMA*(ELAB*PX3(j,4)+PLAB*PX3(j,3))
          PUP(5,j)=PX3(j,5)
       ENDDO

      ENDIF                     ! IF(PMAS(ABS(IDUP(I)),2).gt.0.)
      ENDDO                     ! DO I=3,NUP

      RETURN
      END
