/*$Log */
#include <stdio.h>
#include "comphep/include/4_vector.h"
#include "comphep/include/phys_val.h"
#include "comphep/include/e_tools.h"
#include "comphep/include/out_ext.h"
#include "tag_reader.h"
#include "tag_parser.h"
#include "fill.h"
#include "event_reader.h"

static void
wrongParam (int N)
{
  if (N)
    fprintf (stderr, "Wrong parameter %d\n", N);
  else
    fprintf (stderr, "Wrong number of parameters \n");
  fprintf (stderr, "Parameters:\n"
	   " 1- file name,\n"
	   " 2- name of variable,\n"
	   " 3- minimum limit,\n"
	   " 4- maximum limit,\n"
	   " 5- number of bins(<=300).\n");
}


int
main (int argc, char **argv)
{
  int i, j, k, n;
  int nbin;
  int Nproc;
  int format;
  int npr;
  int max_format = 0;
  long Npoints;
  int *Nevents;
  int *Npartons;
  int **pnum;

  char key;
  char plist[MAXNP];
  char *name_proc;
  char buf[1000], buff[1000];

  double minX, maxX, X;
  double weight, coef;
  double *CSec;
  double *hist;
  double *dhist;
  double **mass;

  processUP *prUP;
  eventUP *evUP;

  string_comnd com;
  tags *head;
  FILE *tfile;
  FILE *f = fopen (argv[1], "r");
  if (!f)
    {
      fprintf (stderr, "***Error! File not found: %s\n", argv[1]);
      return 2;
    }

  if (argc != 5)
    {
      wrongParam (0);
      return 1;
    }
  if (!checkPhysVal (argv[2], &key, plist))
    {
      wrongParam (1);
      return 1;
    }
  if (sscanf (argv[3], "min=%lf", &minX) != 1)
    {
      wrongParam (2);
      return 1;
    }
  if (sscanf (argv[4], "max=%lf", &maxX) != 1 ||
      minX >= maxX)
    {
      wrongParam (3);
      return 1;
    }


  Npoints = 0;

  head = init_cap (1);
  cup_reader (f, head);
  Nproc = number_proc (head);

  fill_heprup (prUP, head);

  evUP = malloc (Nproc * sizeof (eventUP));

  for (i = 0; i < Nproc; i++)
    prefill_hepeup (&(evUP[i]), head);

  tfile = fopen ("ev1", "a");
  while (fgets (buf, 1000, f))
    {
      sscanf (buf, "%i:%[^\n]", &npr, buff);
      npr--;
      if (npr < Nproc)
	read_event (evUP[npr], buff, format[npr]);
      else
	{
	  fprintf (stderr, "Error:");
	  exit (2);
	}

      fill_pvect (evUP[npr]);
      X = calcPhysVal (key, plist);
      if (minX < X && X < maxX)
	write_event (tfile);
      Nevents[npr]--;
    }

  rewind (tfile);
  do
    {
      npr = read_event (f));
      if (npr)
	afterNevents[npr--]++;
    }
  while (npr)

  final_write (afterNevents);

  return 0;
}
