*************************************************************************
*                       M A I N   program                               *
*          for CompHEP 4.10  -  PYTHIA 6.2 interface                    *
* uses unweighted events from CompHEP output as PYTHIA external process *
*************************************************************************
*  25.11.2001         Ilyin V.A.                                        *
*************************************************************************
      IMPLICIT REAL*8(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
*...PYTHIA common blocks
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON /PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYINT4/MWID(500),WIDS(500,5)
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      SAVE

*...Les Houches Agreement I common blocks
      INCLUDE 'LHA.INC'

*...CompHEP-PYTHIA interface
      INTEGER ISMEAR,IS,IST,NEVPY
      CHARACTER XXX*500,EVFILE*500,CMPRS*500
      COMMON/ISMEAR/ISMEAR
      COMMON/INPARM/IS,IST,NEVPY
      SAVE
      INTEGER NNEV,IEV

****************** read CompHEP output header and input parameters
*...read input parameters from the file (INPARM.DAT)
      OPEN(22,FILE='INPARM.DAT',STATUS='UNKNOWN')

      READ(22,FMT='(A500)') XXX
      READ(22,FMT='(A500)') XXX
      EVFILE = CMPRS(XXX)

      READ(22,FMT='(A500)') XXX
      READ(22,FMT='(i10)') NEVPY
      CLOSE(22)
      IS = 44                              ! channel to read event file
      MSTP(161) = IS
      MSTP(162) = IS
*... input channel for unweighted events 
      OPEN(IS,FILE=EVFILE,STATUS='UNKNOWN')

*...switch to smear the mass of unstable particles in CompHEP out-state
      ISMEAR=1     ! 0 - no Breit-Wigner smearing, 1- yes
*...set some phys. parameters (masses etc) in PYTHIA according to CompHEP
*...default values
      CALL PHPARS
*************   USER can change these switches or add others ********
*...Independent(MSTJ(1)=2)/LUND(=1)/NO(=0) Fragmentation Model switch
      MSTJ(1)=1
*...switch on/off fragmentation and decays
      MSTP(111)=1
*...switch on/off initial QCD and QED state radiation
      MSTP(61)=1
*...switch on/off final state showers
      MSTP(71)=1
*...switch off multiple interactions
      MSTP(81)=1
*...title page off
      MSTU(12)=0
*...no initialization and diff.cross-section maximization print-out
      MSTP(122)=0

********************************************************************
*...initialize PYTHIA (using CompHEP output for kin.frame)
      CALL PYINIT('USER',' ',' ',0d0)
      CALL PHPARS    ! set again phys.parameters according to
                     ! CompHEP default values
*********************************************************
*...generate events by PYTHIA
      NNEV=0
      DO IEV=1,NEVPY
        CALL PYEVNT
        call pylist(1)    ! This is an example of user's routine:
c        read(*,*)           !   to screen out event by event.

*...check end of file with partonic events
        IF (NUP.eq.0) THEN
            goto 300
        ELSE
            NNEV=IEV
        ENDIF
      ENDDO              ! DO 200 IEV=1,NEVPY

300   CLOSE(IS)
*...cross section table
      CALL PYSTAT(1)
      WRITE(*,*) '  Generated events = ',NNEV
      END
